unit hiCryptography;

interface

uses
  Windows, KOL, Share, Debug;

type

  THICryptography = class(TDebug)
    private
      FResult: string;
    public
      _prop_Mode: Byte;
      _prop_StrType: Byte;
      _prop_Key: string;

      _data_Key: THI_Event;
      _data_Data: THI_Event;
      _event_onCrypt: THI_Event;

      procedure _work_doCrypt0(var _Data: TData; Index: Word);
      procedure _var_Result(var _Data: TData; Index: Word);
  end;


  procedure XOREcnryptDecrypt(InData, OutData: Pointer; DataLen: Integer; Key: Pointer; KeyLen: Integer);



implementation


//   XOR-:
// - XOR       ;
// -         ;
// -     -       ;
// -     -  .
// InData, OutData        .
{procedure XOREcnryptDecrypt(InData, OutData: Pointer; DataLen: Integer; Key: Pointer; KeyLen: Integer);
var
  Lk: Integer;
  Pk: Pointer;
begin
  Lk := KeyLen;
  Pk := Key;

  if Lk = 0 then
  begin
    Move(InData^, OutData^, DataLen);
    Exit;
  end;
  
  while DataLen > 0 do
  begin
    PByte(OutData)^ := PByte(InData)^ xor PByte(Pk)^;
    Dec(Lk);
    Inc(NativeInt(Pk));
    Inc(NativeInt(OutData));
    Dec(DataLen);
    Inc(NativeInt(InData));
    
    if Lk = 0 then //    -    
    begin
      Lk := KeyLen;
      Pk := Key;
    end;        
  end;
end;}

//   XOR  -
//  XOR-  ,   
// (   ).
// ,   ,  
procedure XOREcnryptDecrypt(InData, OutData: Pointer; DataLen: Integer; Key: Pointer; KeyLen: Integer);
var
  I, Lk: Integer;
  Pk: Pointer;
begin

  Lk := KeyLen;
  Pk := Key;
  
  if Lk = 0 then
  begin
    Move(InData^, OutData^, DataLen);
    Exit;
  end;
  
  while DataLen >= SizeOf(NativeInt) do
  begin
    if (Lk >= SizeOf(NativeInt)) then
    begin
      PNativeInt(OutData)^ := PNativeInt(InData)^ xor PNativeInt(Pk)^;
      Dec(Lk, SizeOf(NativeInt));
      Inc(NativeInt(Pk), SizeOf(NativeInt));
      Inc(NativeInt(OutData), SizeOf(NativeInt));
      Dec(DataLen, SizeOf(NativeInt));
      Inc(NativeInt(InData), SizeOf(NativeInt));
      
      if Lk = 0 then //    -    
      begin
        Lk := KeyLen;
        Pk := Key;
      end;  
    end
    else //   ,  4- (8-)
    begin
      for I := 1 to SizeOf(NativeInt) do
      begin   
        PByte(OutData)^ := PByte(InData)^ xor PByte(Pk)^;
        Dec(Lk);
        Inc(NativeInt(Pk));
        Inc(NativeInt(OutData));
        Dec(DataLen);
        Inc(NativeInt(InData));
        
        if Lk = 0 then //    -    
        begin
          Lk := KeyLen;
          Pk := Key;
        end;        
      end;
    end;
  end;
  
  //   ,  4- (8-)
  while DataLen > 0 do
  begin
    if Lk = 0 then
    begin
      Lk := KeyLen;
      Pk := Key;
    end;

    PByte(OutData)^ := PByte(InData)^ xor PByte(Pk)^;
    Dec(Lk);
    Inc(NativeInt(Pk));
    Inc(NativeInt(OutData));
    Dec(DataLen);
    Inc(NativeInt(InData));
  end; 
end;



procedure THICryptography._work_doCrypt0(var _Data: TData; Index: Word);
var
  K, D: string;
  Lk, Ld: Integer; 
begin
  D := ReadString(_Data, _data_Data);
  K := ReadString(_Data, _data_Key, _prop_Key);
  
  Ld := BinaryLength(D);
  Lk := BinaryLength(K);
  
  if Ld <> 0 then
  begin
    {$ifdef UNICODE}
    if _prop_StrType = 1 then
      SetLength(FResult, BinaryStrSize(Ld)-1)
    else
    {$endif}
      SetLength(FResult, BinaryStrSize(Ld));
    
    XOREcnryptDecrypt(Pointer(D), Pointer(FResult), Ld, Pointer(K), Lk);
    
    {$ifdef UNICODE}
    if _prop_StrType = 0 then
      PadBinaryBuf(Pointer(FResult), Ld);
    {$endif}
  end
  else
    FResult := '';

  _hi_CreateEvent(_Data, @_event_onCrypt, FResult);
end;

procedure THICryptography._var_Result(var _Data: TData; Index: Word);
begin
  dtString(_Data, FResult);
end;

end.
